<template>
  <div>
    <!-- 左侧树形结构 -->
    <el-container>
      <el-aside width="250px">
        <div class="JKWTree-tree">
          <h3>包装计件单据维护</h3>
          <el-tree :data="treeData" :props="defaultProps" highlight-current="true"
            @node-click="handleNodeClick"></el-tree>
        </div>
      </el-aside>

      <el-container>
        <el-main>
          <!-- 按钮区域 -->
          <div class="gva-table-box">
            <div class="gva-btn-list">
              <el-row :span="6">
                <el-input v-model="searchInfo" placeholder="输入工单编号或产品名称" />
              </el-row>
              <el-button type="primary" :icon="Search" @click="onSearch">搜索</el-button>
              <el-button type="primary" :icon="Refresh">重置</el-button>
              <div style="margin-left: auto;">
                <el-button type="primary" :icon="Download" @click="exportExcel">导出到Excel</el-button>
              </div>
            </div>
            <!-- 数据展示 -->
            <el-table ref="multipleTable" style="width: 100%" tooltip-effect="dark" :data="tableData" row-key="ID"
              highlight-current-row="true" border @selection-change="handleSelectionChange" @row-dblclick="doubleClick">
              <el-table-column type="selection" width="55" />
              <el-table-column align="left" label="员工编号" prop="sczl_bh" />
              <el-table-column align="left" label="员工姓名" prop="name" />
              <el-table-column align="left" label="生产日期" prop="sczl_rq" />
              <el-table-column align="left" label="班组" prop="sczl_bzdh" />
              <el-table-column align="left" label="包装产量" prop="sczl_cl" />
              <el-table-column align="left" label="返工产量" prop="sczl_fgsl" />
              <el-table-column align="left" label="计件产量" prop="sczl_jjcl" />
              <el-table-column align="left" label="相关工单" prop="sczl_gdbh1" />
              <el-table-column align="left" label="创建用户" prop="sys_id" />
              <el-table-column align="left" label="创建时间" prop="sys_rq" />
              <el-table-column align="left" label="修改时间" prop="mod_rq" />
              <el-table-column align="left" label="UNIQID" prop="UniqId" />
            </el-table>
            <!-- 分页 -->
            <div class="gva-pagination">
              <el-pagination layout="total, sizes, prev, pager, next, jumper" :current-page="page" :page-size="limit"
                :page-sizes="[10, 30, 50, 100]" :total="total" @current-change="handleCurrentChange"
                @size-change="handleSizeChange" />
            </div>
          </div>
          <!-- 弹出框 -->
          <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" :title="type === 'create' ? '添加' : '修改'"
            destroy-on-close width="1200px">
            <!-- <el-scrollbar height="500px"> -->
            <el-form :model="formData" label-position="left" ref="elFormRef" :rules="rule">

              <el-row :gutter="20">
                <el-col :span="4">
                  <el-form-item label="日期" prop="id">
                    <el-input v-model="formData.address" :clearable="true" placeholder="2023.12.14" />
                  </el-form-item>
                </el-col>
                <el-col :span="6">
                  <el-form-item label="员工编号" prop="name">
                    <el-row :gutter="20">
                      <el-col :span="12">
                        <el-input v-model="formData.code" :clearable="true" placeholder="ZT01733" />
                      </el-col>
                      <el-col :span="12">
                        <el-input v-model="formData.name" :clearable="true" placeholder="张玉田" />
                      </el-col>
                    </el-row>
                  </el-form-item>
                </el-col>
                <el-col :span="3">
                  <el-form-item label="组别" prop="name">
                    <el-input v-model="formData.image" :clearable="true" placeholder="A班" />
                  </el-form-item>
                </el-col>
              </el-row>

              <el-row :gutter="20">
                <el-col :span="4">
                </el-col>
                <el-col :span="8">
                  <el-row :gutter="20">
                    <el-col :span="14">
                      <el-form-item label="计时时数" prop="id">
                        <el-input v-model="formData.address" :clearable="true" placeholder="0.00" />
                      </el-form-item>
                    </el-col>
                    <el-col :span="10">
                      <el-form-item label="冲月定额" prop="id">
                        <el-input v-model="formData.address" :clearable="true" placeholder="是" />
                      </el-form-item>
                    </el-col>
                  </el-row>
                </el-col>
              </el-row>
              <el-scrollbar height="300px">
                <el-table style="width: 100%" :data="detailData">
                  <el-table-column prop="gdbh" label="工单编号" width="80"></el-table-column>
                  <el-table-column prop="yjgx" label="印件工序" width="80"></el-table-column>
                  <el-table-column prop="gxmc" label="工序名称" width="100"></el-table-column>
                  <el-table-column prop="yjmc" label="印件名称"></el-table-column>
                  <el-table-column prop="bzcl" label="包装产量" width="80"></el-table-column>
                  <el-table-column prop="fgcl" label="返工产量" width="80"></el-table-column>
                  <el-table-column prop="mxsl" label="每箱数量" width="80"></el-table-column>
                  <el-table-column prop="jcxs" label="计产系数" width="80"></el-table-column>
                  <el-table-column prop="ly" label="来源" width="80"></el-table-column>
                  <el-table-column prop="dedh" label="定额代号" width="100"></el-table-column>
                </el-table>
              </el-scrollbar>

              <el-form-item label="其他备注" prop="id" style="margin-top: 10px;">
                <el-input v-model="formData.address" :clearable="true" placeholder="" />
              </el-form-item>

            </el-form>
            <!-- </el-scrollbar> -->
            <template #footer>
              <div class="dialog-footer">
                <el-button @click="closeDialog">取 消</el-button>
                <el-button type="primary" @click="enterDialog">确 定</el-button>
              </div>
            </template>
          </el-dialog>

        </el-main>
      </el-container>
    </el-container>

  </div>
</template>

<script setup>
import {
  createCompany,
  deleteCompany,
  deleteCompanyByIds,
  updateCompany,
  findCompany,
  getCompanyList
} from '@/api/company'

// 全量引入格式化工具 请按需保留
import { getDictFunc, formatDate, formatBoolean, filterDict, ReturnArrImg, onDownloadFile } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { Search, Refresh, Download } from '@element-plus/icons-vue'
import { ref, reactive, onMounted, onBeforeMount } from 'vue'
import { getPackingSideTable, getPackingTable } from '@/api/mes_api_gty/myapi'

defineOptions({
  name: '06-packingDocuments'
})

// 侧边栏数据请求
const treeData = reactive([]);
const getSideData = async () => {
  const response = await getPackingSideTable();
  if (response.code === 0) {
    const transformedData = response.data.map(item => ({
      label: `${item.date.replace(/-/g, '.')}【单据数: ${item.counts}张】`,
      children: item.sys.map(sysItem => ({
        label: `${sysItem.sys_id} 【记录数: ${sysItem.count}张】`,
        params: {
          date: item.date.replace(/\./g, '-'),
          sys_id: sysItem.sys_id,
          total: sysItem.count,
        },
      })),
    }));
    treeData.splice(0, treeData.length, ...transformedData);
  }
};

getSideData();

// 自动化生成的字典（可能为空）以及字段
const formData = ref({
  id: '',
  name: '',
  date: '',
  group: '',
  packingOutput: '',
  reworkOutput: '',
  pieceOutput: '',
  order: '',
  user: '',
  createTime: '',
  updateTime: '',
  uniqid: '',
})

// 验证规则
const rule = reactive({
})

const elFormRef = ref()
const elSearchFormRef = ref()

// =========== 表格控制部分 ===========
const tableData = reactive([])
const detailData = reactive([
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
  {
    gdbh: '2311736',
    yjgx: '01-15',
    gxmc: '包装(圆切)',
    yjmc: '利群(新)小《降焦改版)',
    bzcl: '13.00',
    fgcl: '0.00',
    mxsl: '2500',
    jcxs: '1.000',
    ly: '',
    dedh: '030002002',
  },
])
const total = ref(0)
const page = ref(1)
const limit = ref(10)
const searchInfo = ref('')
const params = {
  date: '',
  sys_id: '',
  page: page.value.toString(),
  limit: limit.value.toString(),
}

// 分页设置
const handleSizeChange = (val) => {
  limit.value = val;
  params.limit = val.toString();
  getTableData();
}

// 页面跳转
const handleCurrentChange = (val) => {
  page.value = val
  params.page = val.toString();
  getTableData()
}

const getTableData = async () => {
  const response = await getPackingTable(params);
  if (response.code === 0) {
    tableData.splice(0, tableData.length, ...response.data.rows);
  }
}

const handleNodeClick = (node, check) => {
  if (node.params) {
    params.date = node.params.date;
    params.sys_id = node.params.sys_id;
    total.value = node.params.total;
    handleCurrentChange(1);
  }
}

// 搜索
function onSearch() {

}
// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () => {
}

// 获取需要的字典 可能为空 按需保留
setOptions()

// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
  multipleSelection.value = val
}

// 批量删除控制标记
const deleteVisible = ref(false)

// 多选删除
const onDelete = async () => {
  const ids = []
  if (multipleSelection.value.length === 0) {
    ElMessage({
      type: 'warning',
      message: '请选择要删除的数据'
    })
    return
  }
  multipleSelection.value &&
    multipleSelection.value.map(item => {
      ids.push(item.ID)
    })
  const res = await deleteCompanyByIds({ ids })
  if (res.code === 0) {
    ElMessage({
      type: 'success',
      message: '删除成功'
    })
    if (tableData.value.length === ids.length && page.value > 1) {
      page.value--
    }
    deleteVisible.value = false
    getTableData()
  }
}

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

// 更新行
const updateCompanyFunc = async (row) => {
  const res = await findCompany({ ID: row.ID })
  type.value = 'update'
  if (res.code === 0) {
    formData.value = res.data.recompany
    dialogFormVisible.value = true
  }
}

// 弹窗控制标记
const dialogFormVisible = ref(false)

// 打开弹窗
const openDialog = () => {
  type.value = 'create'
  dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
  dialogFormVisible.value = false
  formData.value = {
    address: '',
    image: '',
    name: '',
  }
}
// 弹窗确定
const enterDialog = async () => {
  elFormRef.value?.validate(async (valid) => {
    if (!valid) return
    let res
    switch (type.value) {
      case 'create':
        res = await createCompany(formData.value)
        break
      case 'update':
        res = await updateCompany(formData.value)
        break
      default:
        res = await createCompany(formData.value)
        break
    }
    if (res.code === 0) {
      ElMessage({
        type: 'success',
        message: '创建/更改成功'
      })
      closeDialog()
      getTableData()
    }
  })
}

// 双击表格操作
function doubleClick(row, column, event) {
  console.log(row, column, event);
  // updateCompanyFunc(row);
  type.value = 'update';
  dialogFormVisible.value = true
}

// 导出excel
function exportExcel() {
  console.log('导出到excel');
}

// 生命周期钩子
onMounted(async () => {
});
</script >

<style scoped>
.JKWTree-container {
  display: flex;
}

.JKWTree-tree {
  width: 300px;
  background-color: #fff;
  padding: 10px;
  margin-right: 20px;
}

.JKWTree-tree h3 {
  font-size: 15px;
  font-weight: 700;
  margin: 10px 0;
}

.JKWTree-content {
  flex: 1;
}

/* 选中某行时的背景色*/
::v-deep .el-table__body tr.current-row>td {
  background: #ff80ff !important;
}
</style>
